from typing import Optional, Protocol

from pipelex.cogt.inference.inference_job_abstract import InferenceJobAbstract


class InferenceReportDelegate(Protocol):
    def open_registry(self, mission_id: str): ...

    def report_inference_job(self, inference_job: InferenceJobAbstract): ...

    def generate_report(self, mission_id: Optional[str] = None): ...

    def close_registry(self, mission_id: str): ...
